
.const
StartTimer PROTO  :DWORD,  :DWORD,  :DWORD 
EndTimer PROTO 
unite_seconde	equ 1
unite_milliseconde equ 1000
unite_microseconde equ 1000000
BLELOWORD  equ     [0]
BLEHIWORD  equ     [4]	
TIMER_RESULT STRUCT
	periode  dq ?		;1/f
	fseconde dq ?
TIMER_RESULT ENDS
;minimal resolution of QueryPerformanceCounter: 1/1193182 s = 0.84 s
.data
	align 8	
	__timer__pc__frequency__    dq 0
	__timer__pc__count__start   dq 0
	__timer__pc__count__end     dq 0
	;----------- ne pas dplacer ----------
	Number_Periodes   dq 0			;1/frequency
	exetime_in_unite	dq 0
	overhead 		dq 0
	;----------------------------------------
	__timer__loop__counter__    dd 0	
	mille dq 0
	mem_priority 			dd 0
	return_adresse 			dd 0
.code
	
	

;################################################################
StartTimer PROC  boucle:DWORD, unite:DWORD ,priority:DWORD
	;recupere l'adresse de retour
	;pas de parametres
	mov eax,[esp+4]
	mov return_adresse,eax	
	;----------------------------
	pushad
	mov eax,unite
	mov dword ptr mille[0],eax	
	.if boucle == 0
		jmp  FindeStartTimer
	.else
		mov eax,boucle
		mov __timer__loop__counter__,eax
	.endif
	.if priority != 0
		invoke GetCurrentProcess
		push eax
		invoke GetPriorityClass,eax
		mov mem_priority,eax		
		pop eax
		invoke SetPriorityClass, eax, priority	
	.endif	
	invoke QueryPerformanceFrequency, ADDR __timer__pc__frequency__   ;given in Hz
	.IF eax != 0
		;overhead,time to execute function QueryPerformanceCounter
		invoke QueryPerformanceCounter, ADDR __timer__pc__count__start
		invoke QueryPerformanceCounter, ADDR __timer__pc__count__end
		mov   eax,DWORD PTR __timer__pc__count__end[0]
		sub   eax,DWORD PTR __timer__pc__count__start[0]
		mov   ecx,DWORD PTR __timer__pc__count__end[+4]
		sbb   ecx,DWORD PTR __timer__pc__count__start[+4]
		mov	DWORD PTR overhead[0],eax
		mov   DWORD PTR overhead[4],ecx
		;start count
		invoke QueryPerformanceCounter, ADDR __timer__pc__count__start			
	.else
		jmp FindeStartTimer
	.endif	
 FindeStartTimer:
	popad		;---- a ajout au temps -----
         ret
StartTimer endp

;################################################################

EndTimer PROC 
	.if dword ptr mille[0] == 0 || __timer__loop__counter__ == 0
		jmp FindeEndTimer
	.endif
	dec __timer__loop__counter__
	jz @F
	;retablir pile
	add esp,4
	jmp dword ptr return_adresse
	@@:
	pushad
	invoke QueryPerformanceCounter, ADDR __timer__pc__count__end
	;faire la soustraction des deux qword
	;c++ traduction
	mov   eax,DWORD PTR __timer__pc__count__end[0]
	sub   eax,DWORD PTR __timer__pc__count__start[0]
	mov   ecx,DWORD PTR __timer__pc__count__end[+4]
	sbb   ecx,DWORD PTR __timer__pc__count__start[+4]
	mov	DWORD PTR Number_Periodes[0],eax
	mov   DWORD PTR Number_Periodes[4],ecx
	;enlever overhead	
	mov   eax,DWORD PTR Number_Periodes[0]
	sub   eax,DWORD PTR overhead[0]
	mov   ecx,DWORD PTR Number_Periodes[+4]
	sbb   ecx,DWORD PTR overhead[+4]
	mov	DWORD PTR Number_Periodes[0],eax
	mov   DWORD PTR Number_Periodes[4],ecx	
	
	;-----------------------------------------------
	;double exeTime_in_ms = (double)diffCount * 1000.0 / freq;	
	push dword ptr mille[4]
	push dword ptr mille[0]
	push dword ptr Number_Periodes[4]
	push dword ptr Number_Periodes[0]
	call _allmul
	mov 	dword ptr exetime_in_unite[0],eax
	mov 	dword ptr exetime_in_unite[4],edx
	push dword ptr __timer__pc__frequency__[4]
	push dword ptr __timer__pc__frequency__[0]
	push dword ptr exetime_in_unite[4]
	push dword ptr exetime_in_unite[0]	
	call 	aulldiv
	mov dword ptr exetime_in_unite[0],eax
	mov dword ptr exetime_in_unite[4],edx
	.if mem_priority != 0
		invoke GetCurrentProcess
		invoke SetPriorityClass, eax, mem_priority
		mov mem_priority,0			
	.endif
	mov dword ptr mille[0],0
	popad
	lea eax,Number_Periodes

 FindeEndTimer:
         ret
EndTimer endp



_allmul PROC NEAR
.FPO (0, 4, 0, 0, 0, 0)

A       EQU     [esp + 4]       ; stack address of a
B       EQU     [esp + 12]      ; stack address of b

;
;       AHI, BHI : upper 32 bits of A and B
;       ALO, BLO : lower 32 bits of A and B
;
;             ALO * BLO
;       ALO * BHI
; +     BLO * AHI
; ---------------------
;

        mov     eax,BLEHIWORD(A)
        mov     ecx,BLEHIWORD(B)
        or      ecx,eax         ;test for both hiwords zero.
        mov     ecx,BLELOWORD(B)
        jnz     short hard      ;both are zero, just mult ALO and BLO

        mov     eax,BLELOWORD(A)
        mul     ecx

        ret     16              ; callee restores the stack

hard:
        push    ebx
.FPO (1, 4, 0, 0, 0, 0)

; must redefine A and B since esp has been altered

A2      EQU     [esp + 8]       ; stack address of a
B2      EQU     [esp + 16]      ; stack address of b

        mul     ecx             ;eax has AHI, ecx has BLO, so AHI * BLO
        mov     ebx,eax         ;save result

        mov     eax,BLELOWORD(A2)
        mul     dword ptr BLEHIWORD(B2) ;ALO * BHI
        add     ebx,eax         ;ebx = ((ALO * BHI) + (AHI * BLO))

        mov     eax,BLELOWORD(A2)  ;ecx = BLO
        mul     ecx             ;so edx:eax = ALO*BLO
        add     edx,ebx         ;now edx has all the LO*HI stuff

        pop     ebx

        ret     16              ; callee restores the stack

_allmul ENDP






;################################################################

;--------------------------------------------------------------------
	
;***
;ulldiv.asm - unsigned long divide routine
;
;       Copyright (c) Microsoft Corporation. All rights reserved.
;
;Purpose:
;       defines the unsigned long divide routine
;           _aulldiv
;
;*******************************************************************************


;***
;ulldiv - unsigned long divide
;
;Purpose:
;       Does a unsigned long divide of the arguments.  Arguments are
;       not changed.
;
;Entry:
;       Arguments are passed on the stack:
;               1st pushed: divisor (QWORD)
;               2nd pushed: dividend (QWORD)
;
;Exit:
;       EDX:EAX contains the quotient (dividend/divisor)
;       NOTE: this routine removes the parameters from the stack.
;
;Uses:
;       ECX
;
;Exceptions:
;
;*******************************************************************************

.code
aulldiv        PROC NEAR
.FPO (2, 4, 0, 0, 0, 0)

        push    ebx
        push    esi

; Set up the local stack and save the index registers.  When this is done
; the stack frame will look as follows (assuming that the expression a/b will
; generate a call to uldiv(a, b)):
;
;               -----------------
;               |               |
;               |---------------|
;               |               |
;               |--divisor (b)--|
;               |               |
;               |---------------|
;               |               |
;               |--dividend (a)-|
;               |               |
;               |---------------|
;               | return addr** |
;               |---------------|
;               |      EBX      |
;               |---------------|
;       ESP---->|      ESI      |
;               -----------------
;

DVND    equ     [esp + 12]      ; stack address of dividend (a)
DVSR    equ     [esp + 20]      ; stack address of divisor (b)

;
; Now do the divide.  First look to see if the divisor is less than 4194304K.
; If so, then we can use a simple algorithm with word divides, otherwise
; things get a little more complex.
;

        mov     eax,BLEHIWORD(DVSR) ; check to see if divisor < 4194304K
        or      eax,eax
        jnz     short L1        ; nope, gotta do this the hard way
        mov     ecx,BLELOWORD(DVSR) ; load divisor
        mov     eax,BLEHIWORD(DVND) ; load high word of dividend
        xor     edx,edx
        div     ecx             ; get high order bits of quotient
        mov     ebx,eax         ; save high bits of quotient
        mov     eax,BLELOWORD(DVND) ; edx:eax <- remainder:lo word of dividend
        div     ecx             ; get low order bits of quotient
        mov     edx,ebx         ; edx:eax <- quotient hi:quotient lo
        jmp     short L2        ; restore stack and return

;
; Here we do it the hard way.  Remember, eax contains DVSRHI
;

L1:
        mov     ecx,eax         ; ecx:ebx <- divisor
        mov     ebx,BLELOWORD(DVSR)
        mov     edx,BLEHIWORD(DVND) ; edx:eax <- dividend
        mov     eax,BLELOWORD(DVND)
L3:
        shr     ecx,1           ; shift divisor right one bit; hi bit <- 0
        rcr     ebx,1
        shr     edx,1           ; shift dividend right one bit; hi bit <- 0
        rcr     eax,1
        or      ecx,ecx
        jnz     short L3        ; loop until divisor < 4194304K
        div     ebx             ; now divide, ignore remainder
        mov     esi,eax         ; save quotient

;
; We may be off by one, so to check, we will multiply the quotient
; by the divisor and check the result against the orignal dividend
; Note that we must also check for overflow, which can occur if the
; dividend is close to 2**64 and the quotient is off by 1.
;

        mul     dword ptr BLEHIWORD(DVSR) ; QUOT * BLEHIWORD(DVSR)
        mov     ecx,eax
        mov     eax,BLELOWORD(DVSR)
        mul     esi             ; QUOT * BLELOWORD(DVSR)
        add     edx,ecx         ; EDX:EAX = QUOT * DVSR
        jc      short L4        ; carry means Quotient is off by 1

;
; do long compare here between original dividend and the result of the
; multiply in edx:eax.  If original is larger or equal, we are ok, otherwise
; subtract one (1) from the quotient.
;

        cmp     edx,BLEHIWORD(DVND) ; compare hi words of result and original
        ja      short L4        ; if result > original, do subtract
        jb      short L5        ; if result < original, we are ok
        cmp     eax,BLELOWORD(DVND) ; hi words are equal, compare lo words
        jbe     short L5        ; if less or equal we are ok, else subtract
L4:
        dec     esi             ; subtract 1 from quotient
L5:
        xor     edx,edx         ; edx:eax <- quotient
        mov     eax,esi

;
; Just the cleanup left to do.  edx:eax contains the quotient.
; Restore the saved registers and return.
;

L2:

        pop     esi
        pop     ebx

        ret     16

aulldiv        ENDP
;---------------------------------------------------------------------------------------------
	
difftime64 PROC _b$:QWORD,_a$:QWORD
	Local tv81:QWORD
	;ZEROLOCALES tv81
; Line 44
	cmp	DWORD PTR _a$[+4], 0
	jl	SHORT $LN6@difftime64
	jg	SHORT $LN5@difftime64
	cmp	DWORD PTR _a$[+0], 0
	jb	SHORT $LN6@difftime64
$LN5@difftime64:
	cmp	DWORD PTR _b$[+4], 0
	jg	SHORT $LN2@difftime64
	jl	SHORT $LN6@difftime64
	cmp	DWORD PTR _b$[+0], 0
	jae	SHORT $LN2@difftime64
$LN6@difftime64:
	;-------- modif -------------------
	;call	__errno
	;mov	DWORD PTR [eax], 22			; 00000016H
	mov eax,0
	fldz
	jmp	SHORT $LN3@difftime64
$LN2@difftime64:
; Line 46
	mov	eax, DWORD PTR _b$[+0]
	sub	eax, DWORD PTR _a$[+0]
	mov	ecx, DWORD PTR _b$[+4]
	sbb	ecx, DWORD PTR _a$[+4]
	mov	DWORD PTR tv81[+0], eax
	mov	DWORD PTR tv81[+4], ecx
	mov eax,1
	fild	QWORD PTR tv81[+0]
$LN3@difftime64:
; Line 47
	ret	
difftime64 ENDP	

;--------------------------------------------------------------------------------
time64 PROC _timeptr$:DWORD
	Local _nt_time$:QWORD,_tim$:QWORD
	;ZEROLOCALES _tim$
	lea	edx, DWORD PTR _nt_time$
	invoke GetSystemTimeAsFileTime,edx
; Line 63
	mov	ecx, DWORD PTR _nt_time$[+0]
	sub	ecx, -717324288				; d53e8000H
	mov	edx, DWORD PTR _nt_time$[+4]
	sbb	edx, 27111902				; 019db1deH
	push	0
	push	10000000				; 00989680H
	push	edx
	push	ecx
	call	aulldiv
	mov	DWORD PTR _tim$[+0], eax
	mov	DWORD PTR _tim$[+4], edx
; Line 65
	cmp	DWORD PTR _tim$[+4], 7
	jl	SHORT $LN2@time64
	jg	SHORT $LN5@time64
	cmp	DWORD PTR _tim$[+0], -1824493569	; 93406fffH
	jbe	SHORT $LN2@time64
$LN5@time64:
; Line 66
	mov	DWORD PTR _tim$[+0], -1
	mov	DWORD PTR _tim$[+4], -1
$LN2@time64:
; Line 68
	cmp	DWORD PTR _timeptr$[+0], 0
	je	SHORT $LN1@time64
; Line 69
	mov	eax, DWORD PTR _timeptr$[+0]
	mov	ecx, DWORD PTR _tim$[+0]
	mov	DWORD PTR [eax], ecx
	mov	edx, DWORD PTR _tim$[+4]
	mov	DWORD PTR [eax+4], edx
$LN1@time64:
; Line 71
	mov	eax, DWORD PTR _tim$[+0]
	mov	edx, DWORD PTR _tim$[+4]
	ret	
time64 ENDP
.data
	jour 	db "dimanche ",0
		db "lundi ",0
		db "mardi ",0
		db "mercredi ",0
		db "jeudi ",0
		db "vendredi ",0
		db "samedi ",0,0		
	mois	db "janvier ",0
		db "fevrier ",0
		db "mars ",0
		db "avril ",0
		db "mai ",0
		db "juin ",0
		db "juillet ",0
		db "aut ",0
		db "septembre ",0
		db "octobre ",0
		db "novembre ",0
		db "decembre ",0,0
fMtStrinG db "%lu",0
heure db ":",0
espace db " ",0
chrono1 SYSTEMTIME <>
chrono2 SYSTEMTIME <>
Top dd 0
NullResult db "0:",0
refchrono db "Heures:Minutes:Secondes:Millimes",0
comment 
typedef struct _SYSTEMTIME {
  WORD wYear;
  WORD wMonth;
  WORD wDayOfWeek;
  WORD wDay;
  WORD wHour;
  WORD wMinute;
  WORD wSecond;
  WORD wMilliseconds;
} SYSTEMTIME, *PSYSTEMTIME;
	
				
.code
;################################################################
DateHeure PROC  pbuf:DWORD 
			Local SystemTime:SYSTEMTIME			
			Local partiel[20]:BYTE
			Local adheure:DWORD
			Local  retour:DWORD
         mov retour,0
	invoke GetLocalTime,addr SystemTime
	movzx ecx,SystemTime.wDayOfWeek
	lea edx,jour
	parcoursjour:
	.if ecx == 0		;jour dmarre a zero lundi
		invoke lstrcpy,pbuf,edx
	.else
		;avanc au jour suivant
		@@:
		.if byte ptr [edx] != 0
			inc edx
			jmp @B
		.endif
		inc edx
		.if byte ptr [edx] == 0
			;erreur
			jmp FindeDateHeure
		.else
			dec ecx
			jmp parcoursjour
		.endif
	.endif
	invoke wsprintf,addr partiel,ADDR fMtStrinG,SystemTime.wDay
	invoke lstrcat,pbuf,addr partiel
	invoke lstrcat,pbuf,addr espace
	;chercher le mois
	movzx ecx,SystemTime.wMonth
	lea edx,mois
	parcoursmois:
	.if ecx == 1		;mois dmarre a un lundi
		invoke lstrcat,pbuf,edx
		invoke lstrcat,pbuf,addr espace
	.else
		;avanc au jour suivant
		@@:
		.if byte ptr [edx] != 0
			inc edx
			jmp @B
		.endif
		inc edx
		.if byte ptr [edx] == 0
			;erreur
			jmp FindeDateHeure
		.else
			dec ecx
			jmp parcoursmois
		.endif
	.endif	
	invoke wsprintf,addr partiel,ADDR fMtStrinG,SystemTime.wYear	
	invoke lstrcat,pbuf,addr partiel
	invoke lstrcat,pbuf,addr espace
	invoke wsprintf,addr partiel,ADDR fMtStrinG,SystemTime.wHour
	invoke lstrcat,addr partiel,addr heure
	invoke lstrcat,pbuf,addr partiel
	invoke wsprintf,addr partiel,ADDR fMtStrinG,SystemTime.wMinute
	invoke lstrcat,pbuf,addr partiel				

 FindeDateHeure:
         mov eax,retour
         ret
DateHeure endp

JourMilli = 24 * 60 * 60 * 1000	;526 5c00h dword
HeureMilli = 60 * 60 * 1000
MinuteMilli = 60 * 1000
SecondeMilli = 1000
;################################################################
TopChrono PROC pchain:DWORD
			Local  cumul1:DWORD,cumul2,diff
			Local  result[30]:BYTE,partiel[10]:BYTE
			Local  retour:DWORD
         mov retour,1
	   mov cumul1,0
	   mov cumul2,0	
	.if Top == 0
		invoke GetLocalTime,addr chrono1
		mov Top,1
		jmp FindeTopChrono
	.else
		invoke GetLocalTime,addr chrono2
		mov Top,0
		;--- 1 heure ------
		movzx eax,chrono1.wHour
		mov edx,0
		mov ecx,HeureMilli
		mul ecx
		add cumul1,eax
		;--1 minute ----------
		movzx eax,chrono1.wMinute
		mov edx,0
		mov ecx,MinuteMilli
		mul ecx
		add cumul1,eax
		;------ 1 seconde --------
		movzx eax,chrono1.wSecond
		mov edx,0
		mov ecx,SecondeMilli
		mul ecx
		add cumul1,eax				
		;------ 1 milliseconde --------
		movzx eax,chrono1.wMilliseconds
		add cumul1,eax
		;----- 2 -----------------------						
		;--- 1 heure ------
		movzx eax,chrono2.wHour
		mov edx,0
		mov ecx,HeureMilli
		mul ecx
		add cumul2,eax
		;--1 minute ----------
		movzx eax,chrono2.wMinute
		mov edx,0
		mov ecx,MinuteMilli
		mul ecx
		add cumul2,eax
		;------ 1 seconde --------
		movzx eax,chrono2.wSecond
		mov edx,0
		mov ecx,SecondeMilli
		mul ecx
		add cumul2,eax				
		;------ 1 milliseconde --------
		movzx eax,chrono2.wMilliseconds
		add cumul2,eax								
	.endif
	;limite de minuit franchit ?
	mov eax,cumul1
	.if eax > cumul2 ; pass minuit
		mov edx,JourMilli
		sub edx,eax
		add edx,cumul2
		mov diff,edx
	.else
		mov edx,cumul2
		sub edx,cumul1
		mov diff,edx
	.endif
	;retraduire diff en heure:minute;seconde:millieme
	mov byte ptr [result],0
	;--- heure -------------	
	mov eax,diff
	.if eax > HeureMilli
		mov edx,0
		mov ecx,HeureMilli
		div ecx
		mov diff,edx
		;eax contient le nombre d'heures
		mov edx,eax
		invoke wsprintf,addr partiel,ADDR fMtStrinG,edx
		invoke lstrcat,addr partiel,addr heure
		invoke lstrcat,addr result,addr partiel
	.else
		invoke lstrcat,addr result,addr NullResult		
	.endif
	;--- Minute -------------	
	mov eax,diff
	.if eax > MinuteMilli
		mov edx,0
		mov ecx,MinuteMilli
		div ecx
		mov diff,edx
		;eax contient le nombre d'heures
		mov edx,eax
		invoke wsprintf,addr partiel,ADDR fMtStrinG,edx
		invoke lstrcat,addr partiel,addr heure
		invoke lstrcat,addr result,addr partiel
	.else
		invoke lstrcat,addr result,addr NullResult		
	.endif
	;--- Seconde -------------	
	mov eax,diff
	.if eax > SecondeMilli
		mov edx,0
		mov ecx,SecondeMilli
		div ecx
		mov diff,edx
		;eax contient le nombre d'heures
		mov edx,eax
		invoke wsprintf,addr partiel,ADDR fMtStrinG,edx
		invoke lstrcat,addr partiel,addr heure
		invoke lstrcat,addr result,addr partiel
	.else
		invoke lstrcat,addr result,addr NullResult		
	.endif
	;--- MilliSeconde -------------	
	mov edx,diff
	invoke wsprintf,addr partiel,ADDR fMtStrinG,edx
	invoke lstrcat,addr result,addr partiel
	.if pchain == 0		
		invoke MessageBox,NULL,ADDR result,addr refchrono,MB_OK
	.else
		invoke lstrcpy,pchain,addr result
	.endif		
	;invoke RtlZeroMemory,addr cumul1,sizeof SYSTEMTIME
	;invoke RtlZeroMemory,addr cumul2,sizeof SYSTEMTIME	
 FindeTopChrono:
         mov eax,retour
         ret
TopChrono endp




