.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
;include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
include realtime.inc
.const
BaseN PROTO  :DWORD,  :DWORD,:DWORD
Division PROTO  :DWORD ,:DWORD
cpudiv PROTO  :DWORD,  :DWORD 
uncinquieme real8 0.2
.data
RefHexTamp db "0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F"
Chiffre db 50 dup (0)
result  db 50 dup(0)
.code
;translate a number,value,in a base from 2 to 16
start:
	;division par 2
	;invoke Division,85,5
	;jmp fin
	push 1
	call ShowCpu	; print brand string and SSE level


	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000	; One Mio would be a typical value
	REPEAT 5
		;invoke Sleep, SleepMs
		invoke StartTimer,LOOP_COUNT,unite_microseconde,HIGH_PRIORITY_CLASS
				invoke Division, 12345678,10
		invoke EndTimer
		mov eax,dword ptr Number_Periodes[0]
		print str$(eax), 9, "periodes for Division", 13, 10
		
		invoke StartTimer,LOOP_COUNT,unite_microseconde,HIGH_PRIORITY_CLASS		
				invoke cpudiv, 12345678,10
		invoke EndTimer				
		mov eax,dword ptr Number_Periodes[0]
		print str$(eax), 9, "periodes for cpudiv", 13, 10
						
		
		print chr$(13, 10)
	ENDM
	inkey chr$(13, 10, "--- ok ---", 13)
	fin:
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

;################################################################
Division PROC  dividende:DWORD,diviseur:DWORD
	;suite de somme	resultat 12D687 reste 8
	;division par 8
	mov edx,dividende
	shr edx,3
	mov eax,edx
	push edx
	;acroissement des sommes si 10 au lieu de 8 = eax * 2
	;shl eax,1
	;nombre de termes  enlever pour retrouver la valeur du dividende
	fild dword ptr [esp]
	fmul real8 ptr uncinquieme
	fistp dword ptr [esp]
	pop edx
	sub  eax,edx
	mov edx,0
	mov ecx,10
	push eax
	mul ecx
	mov edx,dividende		
	sub edx,eax
	pop eax
	
 FindeDivision:
         ret
Division endp

;################################################################

cpudiv PROC  dividende:DWORD,diviseur:DWORD
			Local  retour:DWORD
         mov retour,1
	mov eax,dividende
	mov edx,0
	mov ecx,diviseur
	div ecx

 Findecpudiv:
         mov eax,retour
         ret
cpudiv endp

;################################################################


end start

